Bug 823286 - Review Request: dmlite - Common libraries for grid data management and storage
Review Request: dmlite - Common libraries for grid data management and storage
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Adrien Devresse
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-20 11:27 EDT by Ricardo Rocha
Modified: 2012-07-12 18:34 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-06-22 04:35:44 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
adev88: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ricardo Rocha 2012-05-20 11:27:12 EDT
Spec URL: http://rocha.web.cern.ch/rocha/fedora/dmlite.spec
SRPM URL: http://rocha.web.cern.ch/rocha/fedora/dmlite-0.2.0-2.src.rpm
Description: 
This package provides a set of common libraries and plugins that implement logic for data management and storage on the grid.
Comment 1 Adrien Devresse 2012-05-31 05:26:28 EDT
I take care of it
Comment 2 Adrien Devresse 2012-05-31 05:51:05 EDT
First comments : 

-> Compilation failure on Rawhide :

+ /usr/bin/cmake -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_PREFIX:PATH=/usr -DINCLUDE_INSTALL_DIR:PATH=/usr/include -DLIB_INSTALL_DIR:PATH=/usr/lib64 -DSYSCONF_INSTALL_DIR:PATH=/etc -DSHARE_INSTALL_PREFIX:PATH=/usr/share -DLIB_SUFFIX=64 -DBUILD_SHARED_LIBS:BOOL=ON . -DCMAKE_INSTALL_PREFIX=/
-- The C compiler identification is GNU 4.7.0
-- The CXX compiler identification is GNU 4.7.0
-- Check for working C compiler: /usr/lib64/ccache/gcc
-- Check for working C compiler: /usr/lib64/ccache/gcc -- works
-- Detecting C compiler ABI info
-- Detecting C compiler ABI info - done
-- Check for working CXX compiler: /usr/lib64/ccache/c++
-- Check for working CXX compiler: /usr/lib64/ccache/c++ -- works
-- Detecting CXX compiler ABI info
-- Detecting CXX compiler ABI info - done
-- dpm includes found in /usr/include
-- Found dpm: /lib64/libdpm.so  
-- Found PROTOBUF: /usr/lib64/libprotobuf.so  
CMake Error at /usr/share/cmake/Modules/FindPackageHandleStandardArgs.cmake:97 (MESSAGE):
  Could NOT find JNI (missing: JAVA_AWT_LIBRARY JAVA_JVM_LIBRARY
  JAVA_INCLUDE_PATH JAVA_INCLUDE_PATH2 JAVA_AWT_INCLUDE_PATH)
Call Stack (most recent call first):
  /usr/share/cmake/Modules/FindPackageHandleStandardArgs.cmake:288 (_FPHSA_FAILURE_MESSAGE)
  /usr/share/cmake/Modules/FindJNI.cmake:240 (FIND_PACKAGE_HANDLE_STANDARD_ARGS)
  tests/CMakeLists.txt:73 (find_package)
-- Configuring incomplete, errors occurred!
Erreur de construction de RPM :
erreur : Mauvais statut de sortie pour /var/tmp/rpm-tmp.ocywBF (%build)
    Mauvais statut de sortie pour /var/tmp/rpm-tmp.ocywBF (%build)
Child return code was: 1
EXCEPTION: Command failed. See logs for output.
 # ['bash', '--login', '-c', 'rpmbuild -bb --target x86_64 --nodeps builddir/build/SPECS/dmlite.spec']
Traceback (most recent call last):
  File "/usr/lib/python2.7/site-packages/mockbuild/trace_decorator.py", line 70, in trace
    result = func(*args, **kw)
  File "/usr/lib/python2.7/site-packages/mockbuild/util.py", line 352, in do
    raise mockbuild.exception.Error, ("Command failed. See logs for output.\n # %s" % (command,), child.returncode)
Error: Command failed. See logs for output.
 # ['bash', '--login', '-c', 'rpmbuild -bb --target x86_64 --nodeps builddir/build/SPECS/dmlite.spec']
LEAVE do --> EXCEPTION RAISED


-> Why a subversion buildrequires dependency ? Fetching file at build time in a src.rpm is forbidden by the Fedora packaging policy.

-> ISA macro is not needed by the BuildRequires field, only by the Requires fields.

-> Requires:	mysql    -> has a missing ISA macro

-> %package libs, Summary:	Libraries  -> Could it have a more explicit summary with the component name ?

-> It is better for readability to use  %-style variables pr $-style variables, but not mixing both

-> I see a cppunit-devel a dependency but no %check section for Unit test execution.

-> %{_mandir} macro and %{_docdir} macro could be used.

-> It is better to avoid %cmake macro overloading when possible :  -DCMAKE_INSTALL_PREFIX=/
Comment 3 Ricardo Rocha 2012-06-05 11:02:41 EDT
Hi.

Thanks for the review.

New spec and srpm:
http://rocha.web.cern.ch/rocha/fedora/dmlite.spec
http://rocha.web.cern.ch/rocha/fedora/dmlite-0.2.0-3.src.rpm

Koji builds (success):
http://koji.fedoraproject.org/koji/taskinfo?taskID=4129331 (rawhide)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4129325 (5E)
http://koji.fedoraproject.org/koji/taskinfo?taskID=4129329 (6E)

See inline for details on the fixes.

Also added an additional patch for a missing include for proper test compilation on rawhide.

Thanks again,
Ricardo

(In reply to comment #2)
> First comments : 
> 
> -> Compilation failure on Rawhide :
> 
> + /usr/bin/cmake -DCMAKE_VERBOSE_MAKEFILE=ON
> -DCMAKE_INSTALL_PREFIX:PATH=/usr -DINCLUDE_INSTALL_DIR:PATH=/usr/include
> -DLIB_INSTALL_DIR:PATH=/usr/lib64 -DSYSCONF_INSTALL_DIR:PATH=/etc
> -DSHARE_INSTALL_PREFIX:PATH=/usr/share -DLIB_SUFFIX=64
> -DBUILD_SHARED_LIBS:BOOL=ON . -DCMAKE_INSTALL_PREFIX=/
> -- The C compiler identification is GNU 4.7.0
> -- The CXX compiler identification is GNU 4.7.0
> -- Check for working C compiler: /usr/lib64/ccache/gcc
> -- Check for working C compiler: /usr/lib64/ccache/gcc -- works
> -- Detecting C compiler ABI info
> -- Detecting C compiler ABI info - done
> -- Check for working CXX compiler: /usr/lib64/ccache/c++
> -- Check for working CXX compiler: /usr/lib64/ccache/c++ -- works
> -- Detecting CXX compiler ABI info
> -- Detecting CXX compiler ABI info - done
> -- dpm includes found in /usr/include
> -- Found dpm: /lib64/libdpm.so  
> -- Found PROTOBUF: /usr/lib64/libprotobuf.so  
> CMake Error at
> /usr/share/cmake/Modules/FindPackageHandleStandardArgs.cmake:97 (MESSAGE):
>   Could NOT find JNI (missing: JAVA_AWT_LIBRARY JAVA_JVM_LIBRARY
>   JAVA_INCLUDE_PATH JAVA_INCLUDE_PATH2 JAVA_AWT_INCLUDE_PATH)
> Call Stack (most recent call first):
>   /usr/share/cmake/Modules/FindPackageHandleStandardArgs.cmake:288
> (_FPHSA_FAILURE_MESSAGE)
>   /usr/share/cmake/Modules/FindJNI.cmake:240
> (FIND_PACKAGE_HANDLE_STANDARD_ARGS)
>   tests/CMakeLists.txt:73 (find_package)
> -- Configuring incomplete, errors occurred!
> Erreur de construction de RPM :
> erreur : Mauvais statut de sortie pour /var/tmp/rpm-tmp.ocywBF (%build)
>     Mauvais statut de sortie pour /var/tmp/rpm-tmp.ocywBF (%build)
> Child return code was: 1
> EXCEPTION: Command failed. See logs for output.
>  # ['bash', '--login', '-c', 'rpmbuild -bb --target x86_64 --nodeps
> builddir/build/SPECS/dmlite.spec']
> Traceback (most recent call last):
>   File "/usr/lib/python2.7/site-packages/mockbuild/trace_decorator.py", line
> 70, in trace
>     result = func(*args, **kw)
>   File "/usr/lib/python2.7/site-packages/mockbuild/util.py", line 352, in do
>     raise mockbuild.exception.Error, ("Command failed. See logs for
> output.\n # %s" % (command,), child.returncode)
> Error: Command failed. See logs for output.
>  # ['bash', '--login', '-c', 'rpmbuild -bb --target x86_64 --nodeps
> builddir/build/SPECS/dmlite.spec']
> LEAVE do --> EXCEPTION RAISED

I missed the JNI requires in the tests, for some reason it would not complain in EPEL. Added a patch to remove it, as it's not needed other than for the hadoop plugin (which is not built by default, and we're not packaging).

> -> Why a subversion buildrequires dependency ? Fetching file at build time
> in a src.rpm is forbidden by the Fedora packaging policy.

Dropped.
 
> -> ISA macro is not needed by the BuildRequires field, only by the Requires
> fields.

Fixed.

> -> Requires:	mysql    -> has a missing ISA macro

Fixed.

> -> %package libs, Summary:	Libraries  -> Could it have a more explicit
> summary with the component name ?

Done.

> -> It is better for readability to use  %-style variables pr $-style
> variables, but not mixing both

Changed RPM_BUILD_ROOT to buildroot.

> -> I see a cppunit-devel a dependency but no %check section for Unit test
> execution.

The package builds tests, but these unfortunately cannot be run at build time, there are some external service dependencies.

If there are some local tests coming in a subsequent release i'll add them.

> -> %{_mandir} macro and %{_docdir} macro could be used.

mandir is used already, defaultdocdir too.

> -> It is better to avoid %cmake macro overloading when possible : 
> -DCMAKE_INSTALL_PREFIX=/

This is currently what the package is relying on, i would leave it if possible.
Comment 4 Adrien Devresse 2012-06-11 12:03:42 EDT

[OK] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

dmlite.src: W: invalid-url Source0: dmlite-0.2.0.tar.gz
dmlite-devel.x86_64: W: no-documentation
dmlite-plugins-adapter.x86_64: W: no-documentation
dmlite-plugins-librarian.x86_64: W: no-documentation
dmlite-plugins-memcached.x86_64: W: no-documentation
dmlite-plugins-mysql.x86_64: W: no-documentation
dmlite-plugins-profiler.x86_64: W: no-documentation
10 packages and 0 specfiles checked; 0 errors, 7 warnings.

-> minor warning, documentation is provided in the doc package

[OK] MUST: The package must be named according to the Package Naming Guidelines .
[OK] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[OK] MUST: The package must meet the Packaging Guidelines .
[OK] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

	-> ASL 2.0 : OK

[OK] MUST: The License field in the package spec file must match the actual license. 
[OK] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[OK] MUST: The spec file must be written in American English. 
[OK] MUST: The spec file for the package MUST be legible. 
[OK] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
[OK] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. 

	-> Build on everything

[OK] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. 



[OK] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[OK] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[OK] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 

[OK] MUST: Packages must NOT bundle copies of system libraries.
[OK] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. 
[OK] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 
[OK] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[OK] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. 
[OK] MUST: Each package must consistently use macros. 
[OK] MUST: The package must contain code, or permissable content. 
[OK] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 
[OK] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. 
[OK] MUST: Header files must be in a -devel package. 
[OK] MUST: Static libraries must be in a -static package. 
[OK] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. 
[OK] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} 
[OK] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[OK] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 
[OK] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[OK] MUST: All filenames in rpm packages must be valid UTF-8. 


[OK] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. 
[OK] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. 
[OK] SHOULD: The reviewer should test that the package builds in mock. 
[OK] SHOULD: The package should compile and build into binary rpms on all supported architectures. 
[OK] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[OK] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. 
[OK] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. 
[OK] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. 

	-> not provided, but can be a good thing in the futur ( not mandatory )

[OK] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. 
[OK] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

Everything is fine for me, Package approved.
Comment 5 Ricardo Rocha 2012-06-11 13:25:33 EDT
New Package SCM Request
=======================
Package Name: dmlite
Short Description: This package provides a set of common libraries and plugins that implement logic for data management and storage on the grid.
Owners: rocha
Branches: f17 el5 el6
InitialCC:
Comment 6 Gwyn Ciesla 2012-06-11 13:42:58 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2012-06-11 17:38:01 EDT
dmlite-0.2.0-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/dmlite-0.2.0-3.el5
Comment 8 Fedora Update System 2012-06-11 17:38:10 EDT
dmlite-0.2.0-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/dmlite-0.2.0-3.el6
Comment 9 Fedora Update System 2012-06-11 17:38:20 EDT
dmlite-0.2.0-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/dmlite-0.2.0-3.fc17
Comment 10 Fedora Update System 2012-06-13 17:31:42 EDT
dmlite-0.2.0-3.fc17 has been pushed to the Fedora 17 testing repository.
Comment 11 Fedora Update System 2012-06-22 04:35:44 EDT
dmlite-0.2.0-3.fc17 has been pushed to the Fedora 17 stable repository.
Comment 12 Fedora Update System 2012-07-12 18:33:15 EDT
dmlite-0.2.0-3.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 13 Fedora Update System 2012-07-12 18:34:21 EDT
dmlite-0.2.0-3.el5 has been pushed to the Fedora EPEL 5 stable repository.

Note You need to log in before you can comment on or make changes to this bug.